<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="4" class="text-align-left">
                            <h3>Status</h3>
                        </el-col>
                        <el-col :span="20">
                            <el-row :gutter="20">
                                <el-col :lg="6" :md="6" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Status" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getStatuses(1, false)" 
                                        @clear="getStatuses(1, false)"/>
                                </el-col>
                                <el-col :lg="8" :md="8" :sm="24" v-if="user.role.slug == 'root'">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getFilterOrganizations"
                                        v-model="filter.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('filter')">
                                        <el-option
                                            v-for="item in filterOrganizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getStatuses(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button size="medium" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="statuses" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Name"
                        width="300">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Description"
                        width="200">
                        <template slot-scope="scope">
                            <span>{{ scope.row.description }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Organization"
                        width="200">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.organization.name).capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        align="center"
                        label="Public"
                        width="100">
                        <template slot-scope="scope">
                            <span v-if="scope.row.ispublic" style="color:#30B08F;"><i class="ion-ios-unlock"></i></span>
                            <span v-else><i class="ion-ios-lock"></i></span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'status', 'viewown']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'status', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="statusForm" :model="statusForm" :rules="statusRules">
                        <aside>
                            <el-alert type="info" description="Add or edit organization status" :closable=false show-icon></el-alert>
                        </aside>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Name" prop="name">
                                    <el-input ref="name" name="name" v-model="statusForm.name" placeholder="Status name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Description" prop="description">
                                    <el-input ref="description" name="description" v-model="statusForm.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-row :gutter="20">
                            <el-col :lg="24" :md="24" :sm="24" v-if="user.role.slug == 'root'">
                                <el-form-item label="Organization" prop="organization">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getOrganizations"
                                        v-model="statusForm.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('content')">
                                        <el-option
                                            v-for="item in organizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>                            
                        </el-row> 
                        <el-row :gutter="20">
                            <el-col :lg="24" :md="24" :sm="24">
                                <el-switch
                                    v-model="statusForm.ispublic"
                                    active-text="Public"
                                    inactive-text="Internal">
                                </el-switch>
                            </el-col>
                        </el-row>                        
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'status', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight, convertAmpersand } from '../../utils/index';
export default {
    name: 'Status',
    directives: {
        permission
    },
    data(){

        var validateOrganization = (rule, value, callback) => {
            if(this.user.role.slug == 'root' && this.statusForm.organization == null){
                return callback(new Error('Organization is required'));
            }
            callback();
        };

        return{
            tableLoading: false,
            dialogLoading: false,
            organizationLoading: false,
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit Status',
                add: 'Add New Status'
            },
            filter: {
                keyword: '',
                organization: null
            },
            statusForm: {
                id: null,
                name: '',
                description: '',
                ispublic: false,
                organization: null
            },
            statusRules: {
                name: [{ 
                    required: true, message: 'Status name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Status name length 255 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9&()\s]{1,255})$/, 
                    message: 'Only letters, numbers, ampersand, brackets and spaces are allowed.', 
                    trigger: 'blur'
                }],
                description: [{ 
                    max: 255, 
                    message: 'Description length maximum 255 characters', 
                    trigger: 'blur'
                }],
                organization: [{ 
                    validator: validateOrganization, trigger: 'change'
                }]
            },
        }
    },
    computed:{
        ...mapGetters('auth', ['user']),
        ...mapGetters('organization', [
            'organizations',
            'filterOrganizations'
        ]),
        ...mapGetters('status', [
            'statuses',
            'pagination'
        ])
    },
    created(){
        const self = this;

        self.getStatuses(1, false);

        if(self.user.role.slug != 'root'){
            self.statusForm.organization = self.user.organization.id; 
        }
    },
    methods: {
        dateFormat,
        tableHeight,
        convertAmpersand,
        getFilterOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'filter'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'content'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getStatuses(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            if(self.filter.organization != null && self.user.role.slug == 'root'){
                params.organization = self.filter.organization;
            }else if(self.user.role.slug != 'root'){
                params.organization = self.user.organization;
            }

            self.$store.dispatch('status/getStatuses', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getStatuses(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showDialog = true;          
            self.$nextTick(() => {
                self.$refs['statusForm'].clearValidate();
            });
        },
        handleEdit(status){
            const self = this;
            self.dialogStatus = 'edit';
            self.showDialog = true;

            self.statusForm.id = status.id;
            self.statusForm.name = status.name;
            self.statusForm.description = status.description;
            self.statusForm.ispublic = status.ispublic;
            self.statusForm.organization = status.organization.id;

            self.getOrganizations(status.organization.name);

            self.$nextTick(() => {
                this.$refs['statusForm'].clearValidate();
            });
        },
        handleDelete(status){
            const self = this;

            self.$confirm('You are about to delete this status. This operation will affecting some modules become malfunction and this operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('status/deleteStatus', {
                    id: status.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.statusForm.validate((valid)=>{
                if(valid){
                    self.dialogLoading = true;

                    let action = 'status/addStatus';
                    let params = {
                        name: self.statusForm.name,
                        description: self.statusForm.description,
                        ispublic: self.statusForm.ispublic,
                        organization: self.statusForm.organization
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'status/editStatus';
                        params.id = self.statusForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.statusForm = {
                id: null,
                name: '',
                description: '',
                ispublic: false,
                organization: null
            };

            self.handleClearOrganization();
        },
        handleClearOrganization(type){
            const self = this;
            self.filter.organization = null;
            self.$store.dispatch('organization/resetOrganizations', {
                type: type
            });
        },
    }
}
</script>